diff --git a/src/mednafen.cpp b/src/mednafen.cpp
index dcdc941..c573166 100644
--- a/src/mednafen.cpp
+++ b/src/mednafen.cpp
@@ -64,6 +64,8 @@ static MDFNSetting MednafenSettings[] =
   { "srwframes", gettext_noop("Number of frames to keep states for when state rewinding is enabled."), MDFNST_UINT, "600", "10", "99999" },
   { "snapname", gettext_noop("If value is true, use an alternate naming scheme(file base and numeric) for screen snapshots."), MDFNST_BOOL, "0"},
   { "dfmd5", gettext_noop("Include the MD5 hash of the loaded game in the filenames of the data file(save states, SRAM backups) Mednafen creates."), MDFNST_BOOL, "1" },
+  { "autoincrement", gettext_noop("Increment slot before saving, if the current one is not empty."),  MDFNST_BOOL, "0"},
+  { "latestsave", gettext_noop("Select the most recent save slot when starting."), MDFNST_BOOL, "0"},
 
   #ifdef NEED_CDEMU
   { "cdrom.lec_eval", gettext_noop("Enable simple error correction of raw data sector rips by evaluating L-EC and EDC data."), MDFNST_BOOL, "1" },
diff --git a/src/state.cpp b/src/state.cpp
index 2cb8413..07f8631 100644
--- a/src/state.cpp
+++ b/src/state.cpp
@@ -780,7 +780,8 @@ void MDFNSS_CheckStates(void)
          }
         }
 
-        CurrentState = 0;
+        CurrentState = (MDFN_GetSettingB("latestsave")) ? RecentlySavedState : 0;
+	 if (CurrentState == -1) CurrentState = 0;
         MDFND_SetStateStatus(NULL);
 }
 
@@ -877,6 +878,9 @@ void MDFNI_SelectState(int w)
 
 void MDFNI_SaveState(const char *fname, const char *suffix, uint32 *fb, MDFN_Rect *LineWidths)
 {
+ if (SaveStateStatus[CurrentState] && MDFN_GetSettingB("autoincrement"))
+	CurrentState = (CurrentState + 1) % 10;
+
  MDFND_SetStateStatus(NULL);
  MDFNSS_Save(fname, suffix, fb, LineWidths);
 }
